unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
  private
    procedure ProcessFile(AFileName: String);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  SATZART_511 = 'SATZART 511: 51101156196419849   498419 19 19 189 4 89494949 49 49 4 984   0';
  SATZART_512 = 'SATZART 512: 51201213<$0>      adsfasd <$1>   d fasd';
  SATZART_513 = 'SATZART 513: 51301 4<$2>   <$3>           1964191asdfasdf';
  SATZART_514 = 'SATZART 514: 514046                      <$4>';

procedure TForm1.Button1Click(Sender: TObject);
begin
  ProcessFile('data.txt');
end;

procedure TForm1.ProcessFile(AFilename: String);
var
  data, lines, L: TStringList;
  i, j: Integer;
  s: String;
  SArr: TStringArray;
  Leer: Boolean;
  ImHeader: Boolean;
begin
  L := TStringList.Create;
  try
    data := TStringList.Create;
    try
      data.LoadFromFile(AFileName);
      imHeader := true;
      for i := 0 to data.Count-1 do begin
        if data[i] = '' then Continue;  // Leerzeilen überspringen
        sArr := data[i].Split(';');
        Leer := true;
        for j := 0 to High(sArr) do
          if sArr[j] <> '' then begin
            Leer := false;
            Break;
          end;
        if Leer then Continue;  // Überspringen, wenn Zeile ;;;; ist
        // Header überspringen
        if sArr[0] = 'Datum' then begin
          imHeader := false;
          Continue;
        end;
        if imHeader then
          Continue;
        L.Add(SATZART_511);
        s := SATZART_512;
        s := StringReplace(s, '$0', sArr[0], []);
        s := StringReplace(s, '$1', sArr[1], []);
        L.Add(s);
        s := SATZART_513;
        s := StringReplace(s, '$2', sArr[2], []);
        s := StringReplace(s, '$3', sArr[3], []);
        L.Add(s);
        s := SATZART_514;
        s := StringReplace(s, '$4', sArr[4], []);
        L.Add(s);
      end;
    finally
      data.Free;
    end;
    Listbox1.Items.Assign(L);
  finally
    L.Free;
  end;
end;

end.

